#pragma section=".intvec"
#pragma section=".checksum"

__root __no_init const u8 Checksum @".checksum";

const u16 flash_begin = (u32)__section_begin(".intvec");
const u16 flash_end   = (u32)__section_begin(".checksum");

void cfg_spi_for_crc(void)
{
 CLK->CKDIVR  = 0;
 CLK->PCKENR1 = CLK_PCKENR1_SPI;

 SPI->CR1 = 0;
 SPI->CR2 = SPI_CR2_SSM | SPI_CR2_SSI | SPI_CR2_CRCEN;
 SPI->CR1 = SPI_CR1_SPE | SPI_CR1_MSTR;
}

//crc = get_crc((u8*)flash_begin, (u8*)flash_end);
//crc = get_crc((u8*)EE_qsw.tab, (u8*)(EE_qsw.tab + Qsw_size));
u8 get_crc(u8 *pt_0, u8 *pt_1)
{
 cfg_spi_for_crc();

 while(pt_0 < pt_1)
 {
  SPI->DR = *pt_0;
  while(SPI->SR and SPI_SR_TXE == 0 or SPI->SR & SPI_SR_BSY)continue;
  pt_0++;
 }

 while(SPI->SR & SPI_SR_BSY)continue;

 SPI->CR2 = SPI_CR2_SSM | SPI_CR2_SSI;
 SPI->CR1 = 0;

 return SPI->TXCRCR;
}

void store_flash_checksum(const u8 val)
{
 u8 *pt = (u8*)&Checksum;
 FLASH_Unlock(FLASH_MEMTYPE_PROG);
 while(FLASH->IAPSR & FLASH_IAPSR_PUL == 0) continue;
 *pt = val;
 FLASH_Lock(FLASH_MEMTYPE_PROG);
}
