
const enum
{
 MC,
 MPC,
 LED,
 KBD,
 COM,
 ERR,
 LAST
}TIM = LAST;
const u8 TIM_NUM = TIM;
volatile u8 Tim[TIM_NUM];

volatile Time Main;
volatile bool D_trg;

extern "C"
{
 INTERRUPT_HANDLER(TIM2_OVF, 13)
 {
  static u16 t2_cnt;
  static u16 t2_frq; //7159 Hz   14318 
  static u16 tim_frq;
  static bool trg = false;

  //       
  if(trg == false)
  {
   t2_frq  = TIM2->ARRH << 8;
   t2_frq |= TIM2->ARRL;
   t2_frq ++;

   t2_frq = EE_storage.Q_frq * (u32)1E3 / t2_frq;
   tim_frq = t2_frq / TSEC -1;

   t2_frq --;

   trg = true;
  }

  if(t2_cnt < t2_frq)
  {
   static u16 cnt;

   t2_cnt++;

   //     TSEC
   if(cnt < tim_frq) cnt++;
   else
   {
    cnt = 0;

    for(u8 i=0; i<TIM_NUM; i++) if(Tim[i])Tim[i]--;
   }
  }
  else
  {
   static u8 seconds;

   t2_cnt = 0;

   seconds++;

   start_adc();

   if(seconds > 59)
   {
    seconds = 0;
    Main.minutes++;

    if(Main.minutes > 59)
    {
     Main.minutes = 0;
     Main.hours++;

     if(Main.hours > 23)
     {
      Main.hours = 0;
      D_trg = true;
     }
    }
   }

   start_adc();
  }

  TIM2->SR1 = 0;
 }

 INTERRUPT_HANDLER(wakeup, 1)
 {
  u8 s = AWU->CSR;
 }
}