class
{
 public:

 void gpio()
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;
  PA_DDR = 0;

  PB_CR1 = 0xf0;  //    
  PB_ODR = 0xf0;
  PB_DDR = 0;

  PC_CR1 = 0;
  PC_ODR = 1<<4|1<<3|1<<2|1<<1; //  
  PC_DDR = 1<<4|1<<3|1<<2|1<<1;

  PD_CR1 = 0xff - (1<<4);
  PD_ODR = 0;
  PD_DDR = 1;

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 1<<4;
  PF_ODR = 0;
  PF_DDR = 0;
 }

 //        
 //  64    u16    1000
 u8 get_ckdiv(u16 cpu_frq)
 {
  u16 frq = cpu_frq;

  for(u8 i = 6; i; i--)
  {
   u32 tmp = frq >> i;

   tmp <<= i;

   if(frq == tmp) return i;
  }

  return 0;
 }

 void clk(void)
 {
  CLK->SWCR = CLK_SWCR_SWEN;
  CLK->SWR  = 0xb4; //HSE as master clock source

#ifndef CLC_DBG
  while(!(CLK->SWCR & CLK_SWCR_SWIF)) continue;
#endif

  CLK->ICKR   |= CLK_ICKR_SWUAH;
  CLK->PCKENR1 = CLK_PCKENR1_TIM1 | CLK_PCKENR1_TIM2;
  CLK->PCKENR2 = CLK_PCKENR2_ADC  | CLK_PCKENR2_AWU;
 }

 void t1(void)
 {
  u16 arr = EE_storage.Q_frq >>1; //2

  TIM1->ARRH  = arr>>8;
  TIM1->ARRL  = (u8)arr;

  arr = (u32)arr *2 *3 * ((1UL<<20)/1000) >>20; //3us

  TIM1->CCR1H = 0;
  TIM1->CCR2H = 0;
  TIM1->CCR3H = 0;
  TIM1->CCR4H = 0;

  TIM1->CCR1L = (u8)arr;
  TIM1->CCR2L = (u8)arr;
  TIM1->CCR3L = (u8)arr;
  TIM1->CCR4L = (u8)arr;

  TIM1->CCMR1 = PWM2 | TIM1_CCMR_OCxPE;
  TIM1->CCMR2 = PWM2 | TIM1_CCMR_OCxPE;
  TIM1->CCMR3 = PWM2 | TIM1_CCMR_OCxPE;
  TIM1->CCMR4 = PWM2 | TIM1_CCMR_OCxPE;

  TIM1->CCER1 = TIM1_CCER1_CC2E | TIM1_CCER1_CC1E;
  TIM1->CCER2 = TIM1_CCER2_CC4E | TIM1_CCER2_CC3E;

  TIM1->EGR   = TIM1_EGR_UG;
  TIM1->BKR   = TIM1_BKR_LOCK;
  TIM1->CR1   = TIM1_CR1_CEN;
 }

 void t2(void)
 {
  u16 arr = (u16)1E3 * (1 << get_ckdiv(EE_storage.Q_frq)) - 1;

  TIM2->ARRH = arr>>8;
  TIM2->ARRL = (u8)arr;

  TIM2->IER  = TIM2_IER_UIE;
  TIM2->EGR  = TIM2_EGR_UG;

  TIM2->CR1  = TIM2_CR1_CEN;
 }

 void adc(void)
 {
  ADC1->CR2  = ADC1_ALIGN_LEFT | ADC1_CR2_SCAN;
  ADC1->CR3  = ADC1_CR3_DBUF;
  ADC1->CSR  = 3;
  ADC1->TDRL = 0x0f;

  ADC1->CR1  = ADC1_PRESSEL_FCPU_D18;
 }

 void awu(void)
 {
  AWU->APR = 0x3e;      // /64
  AWU->TBR = bin(1110); // 5*2048*64/128E3 _5s
  AWU->CSR = AWU_CSR_AWUEN;
 }
}cfg;

